diff --git a/debian/changelog b/debian/changelog
index 0145cf7..4d95002 100644
--- a/debian/changelog
+++ b/debian/changelog
@@ -1,3 +1,13 @@
+s390-tools (2.15.1-0ubuntu6) hirsute; urgency=medium
+
+  * debian/patches/s390-tools-lp1903984-hirsute.patch
+    zcryptstats: Fix handling of partial results with many domains
+    - zconf/zcrypt/zcryptstats.c: code fix to pass the correct next-domain
+      to the subsequent CHSC call of a partial response
+    Thanks to Ingo Franzki <ifranzki@linux.ibm.com>
+
+ -- Frank Heimes <frank.heimes@canonical.com>  Mon, 18 Jan 2021 16:42:40 +0100
+
 s390-tools (2.15.1-0ubuntu5) hirsute; urgency=medium
 
   * No-change rebuild to bring the version in sync with
diff --git a/debian/patches/s390-tools-lp1903984-hirsute.patch b/debian/patches/s390-tools-lp1903984-hirsute.patch
new file mode 100644
index 0000000..99994be
--- /dev/null
+++ b/debian/patches/s390-tools-lp1903984-hirsute.patch
@@ -0,0 +1,48 @@
+Description: zcryptstats fails
+ The zcryptstats tool reports data for only the last two domain IDs.
+ Further, it hangs if one collect data for a complete crypto card,
+ and then one has to kill the ssh session to get back.
+ Patch/commit is:
+ cf2311f cf2311f1f1de17435b49ba8c8697be91705ba031
+ "zcryptstats: Fix handling of partial results with many domains"
+Author: Ingo Franzki <ifranzki@linux.ibm.com>
+Origin: backport
+Bug-IBM: IBM Bugzilla 189183
+Bug-Ubuntu: https://bugs.launchpad.net/bugs/1903984
+Forwarded: not-needed
+Applied-Upstream: upstream patch/commits:
+ https://github.com/ibm-s390-tools/s390-tools/commit/cf2311f1f1de17435b49ba8c8697be91705ba031
+Reviewed-by: Frank Heimes <frank.heimes@canonical.com>
+Last-Update: 2021-01-18
+---
+This patch header follows DEP-3: http://dep.debian.net/deps/dep3/
+--- a/zconf/zcrypt/zcryptstats.c
++++ b/zconf/zcrypt/zcryptstats.c
+@@ -1178,8 +1178,14 @@
+ 		scdmd_area.request.header.code = 0x102d;
+ 		scdmd_area.request.header.length =
+ 				sizeof(struct chsc_scdmd_request);
+-		scdmd_area.request.first_drid.ap_index = card;
+-		scdmd_area.request.first_drid.domain_index = g.min_domain;
++		if (scdmd_area.response.p) {
++			scdmd_area.request.first_drid =
++						scdmd_area.response.crid;
++		} else {
++			scdmd_area.request.first_drid.ap_index = card;
++			scdmd_area.request.first_drid.domain_index =
++								g.min_domain;
++		}
+ 		scdmd_area.request.last_drid.ap_index = card;
+ 		scdmd_area.request.last_drid.domain_index = g.max_domain;
+ 		scdmd_area.request.s = 1;
+@@ -1217,10 +1223,6 @@
+ 		rc = process_apqn_measurement_data(&scdmd_area);
+ 		if (rc != 0)
+ 			break;
+-
+-		if (scdmd_area.response.p)
+-			scdmd_area.request.first_drid =
+-					scdmd_area.response.crid;
+ 	} while (scdmd_area.response.p);
+ 
+ 	return rc;
diff --git a/debian/patches/series b/debian/patches/series
index 7af9f39..73cfb59 100644
--- a/debian/patches/series
+++ b/debian/patches/series
@@ -8,3 +8,4 @@ sg3-utils.patch
 0001-dumpconf-Don-t-run-the-service-in-LXC.patch
 update-install-paths.patch
 0010-no-pie-is-not-a-valid-option-for-ld.patch
+s390-tools-lp1903984-hirsute.patch
